package ever.pipeline;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.regex.Pattern;

public class Clause implements Serializable {

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2;
	private ArrayList<String> values;
	private ArrayList<String> infos;
	private String segmentTyp="";
	private String function="";
	private String wholeTyp="";
	private String root ="";
	public Clause(String cl) {
		values=new ArrayList<String>();
		infos= new ArrayList<String>();
		Scanner sc = new Scanner(cl);
		sc.useDelimiter(Pattern.quote("\n"));
		while (sc.hasNext()) {
			String tmp = sc.next();
			if(tmp.matches(".*( \\(root: )[a-z]*(\\)).*"))
			{
				tmp=tmp.trim();
				String[] split = tmp.split(" ");
				this.root=split[2].replaceAll("(\\))","");				
			}
			
			if(tmp.contains("NP SEGMENT"))
			{
				this.segmentTyp="NP";
				this.wholeTyp=tmp.trim();									
				if(tmp.contains("(DOBJ)"))
					function="(DOBJ)";
				continue;
			}
			
			if(tmp.contains("VP SEGMENT"))
			{
				this.segmentTyp="VP";
				this.wholeTyp=tmp.trim();				
				continue;
			}
			
			if(tmp.contains("PP SEGMENT (PREP):"))
			{
				this.segmentTyp="PP";
				this.wholeTyp=tmp.trim();
				continue;
			}
			
			if(tmp.contains("["))
			{
				tmp=tmp.replaceAll("\\[","");
				tmp=tmp.replaceAll("\\]","");
				tmp=tmp.trim();
				String[] split = tmp.split(" ",2);				
				values.add(split[0]);
				if(split.length>1)
					infos.add(split[1]);
			}
			
			
		}		
	}

	public String getWholeTyp()
	{
		return wholeTyp;
	}
	
	public String getFunction()
	{
		return function;
	}
	public String getSegmentTyp() {
		return segmentTyp;
	}	
	
	public String getTyp()
	{
		return function;
	}
	
	public String getRoot()
	{
		return root;
	}
	
	//Because this this name for the function was used in another Class  
	public String getPP()
	{
		return getValue();
		
	}
	
	public String getValue()
	{
		String out="";
		for(String s: values)
			out+=s+" ";
		
		return out;
	}
	
	
	
	public ArrayList<String> getValues() {
		return values;
	}

	public ArrayList<String> getInfos() {
		return infos;
	}

	

}
